
# Conditional build:
%bcond_without	kernelsrc	# probes which require full kernel source (kvm, btrfs, ext4, regmap)
%bcond_with	verbose		# verbose build (V=1)

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		rel	2
%define		pname	lttng-modules
Summary:	LTTng 2.x kernel modules
Summary(pl.UTF-8):	Moduły jądra LTTng 2.x
Name:		%{pname}%{_alt_kernel}
Version:	2.13.11
Release:	%{rel}@%{_kernel_ver_str}
License:	GPL v2
Group:		Base/Kernel
Source0:	https://lttng.org/files/lttng-modules/%{pname}-%{version}.tar.bz2
# Source0-md5:	306dc7994fd020e7a21e0c64d42ee95c
Patch0:		build.patch
Patch1:		git.patch
URL:		https://lttng.org/
%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:3.0}
%{?with_kernelsrc:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-source >= 3:3.0}}
BuildRequires:	rpmbuild(macros) >= 1.746
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LTTng 2.x kernel modules.

%description -l pl.UTF-8
Moduły jądra LTTng 2.x.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-lttng\
Summary:	LTTng 2.x modules for Linux kernel\
Summary(pl.UTF-8):	Moduły LTTng 2.x dla jądra Linuksa\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-lttng\
LTTng 2.x modules for Linux kernel.\
\
%description -n kernel%{_alt_kernel}-lttng -l pl.UTF-8\
Moduły LTTng 2.x dla jądra Linuksa.\
\
%files -n kernel%{_alt_kernel}-lttng\
%defattr(644,root,root,755)\
%doc %{pname}-%{version}/{ChangeLog,LICENSE,README.md}\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-clock.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-counter-client-percpu-32-modular.ko.*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-counter-client-percpu-64-modular.ko.*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-ring-buffer-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-statedump.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-tracer.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-wrapper.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/lib\
/lib/modules/%{_kernel_ver}/kernel/lttng/lib/lttng-counter.ko.*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lib/lttng-lib-ring-buffer.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/probes\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kretprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-probe-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-uprobes.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/tests\
/lib/modules/%{_kernel_ver}/kernel/lttng/tests/lttng-clock-plugin-test.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/tests/lttng-test.ko*\
\
%post	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%{__make} clean \\\
	KERNELDIR=%{_kernelsrcdir}\
%{__make} \\\
	KERNELDIR=%{_kernelsrcdir}\
p=`pwd`\
%{__make} modules_install \\\
	INSTALL_MOD_PATH=$p/../installed \\\
	INSTALL_MOD_DIR=kernel/lttng \\\
	KERNELDIR=%{_kernelsrcdir}\
%{nil}

%{expand:%create_kernel_packages}

%prep
%setup -qc -n %{name}-%{version}
cd %{pname}-%{version}
%patch0 -p1
%patch1 -p1

%build
cd  %{pname}-%{version}
%{expand:%build_kernel_packages}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT

cp -a installed/* $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT
%changelog
* Mon Mar 18 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lttng-modules.git;a=log;h=master

* Mon Mar 18 2024 Jan Rękorajski <baggins@pld-linux.org> d9b0b60
- rel 2

* Sun Mar 17 2024 Jan Rękorajski <baggins@pld-linux.org> 54b0d17
- pull all fixes from upstream repository

* Sun Mar 17 2024 Jan Rękorajski <baggins@pld-linux.org> 38eac45
- update str(l|s)cpy usage

* Sun Mar 03 2024 Jan Rękorajski <baggins@pld-linux.org> 19f0d5a
- up to 2.13.11

* Sun Nov 19 2023 Jan Rękorajski <baggins@pld-linux.org> 47f8ff3
- upstream fix for building with kernel 6.6

* Fri Nov 17 2023 Jan Rękorajski <baggins@pld-linux.org> cd712e0
- up to 2.13.10, needs fix to build with kernel 6.6

* Sun May 21 2023 Jan Rękorajski <baggins@pld-linux.org> 5561173
- upstream fixes for kernel 6.3, rel 2

* Sat Mar 18 2023 Jakub Bogusz <qboosh@pld-linux.org> 14c056f
- updated to 2.13.9

* Sat Feb 25 2023 Jan Rękorajski <baggins@pld-linux.org> 7d4f477
- fix building with kernel 6.2, rel 3

* Mon Jan 23 2023 Jan Rękorajski <baggins@pld-linux.org> 7af9b85
- rel 2

* Mon Jan 23 2023 Jan Rękorajski <baggins@pld-linux.org> d907f23
- jbd2 types update now also in 5.4.229

* Mon Jan 16 2023 Jan Palus <atler@pld-linux.org> 84d6df0
- jbd2 types update now also in 5.10.163

* Mon Jan 16 2023 Jan Palus <atler@pld-linux.org> f9a77aa
- remove kernel-6.1 patch too

* Mon Jan 16 2023 Jan Palus <atler@pld-linux.org> 2992c7d
- remove jbd2-tid-type patch

* Mon Jan 16 2023 Jan Palus <atler@pld-linux.org> 3dccd48
- up to 2.13.8

* Sun Jan 08 2023 Jan Palus <atler@pld-linux.org> 1d5f719
- fix build with recent kernels; rel 3

* Sun Dec 18 2022 Jan Rękorajski <baggins@pld-linux.org> 20f9ec3
- rel 2

* Sat Dec 17 2022 Jan Rękorajski <baggins@pld-linux.org> 9397200
- upstream fix for building with kernel 6.1

* Fri Oct 28 2022 Jan Rękorajski <baggins@pld-linux.org> cdb8ee3
- up to 2.13.7

* Sun Aug 28 2022 Jan Rękorajski <baggins@pld-linux.org> 695e001
- kernel 5.10 compatibility fix, rel 3

